//
// C++ Interface: chiquadrat
//
// Description: 
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef CHIQUADRAT_H
#define CHIQUADRAT_H

#include "modeldiagramadapter.h"
#include <QVariant>
class QDoubleSpinBox;
class QLabel;
class QAbstractItemModel;
class Diagram;
class QGridLayout;

/**
	@author Arne Schmitt <arne@as4m.de>
*/
class ChiQuadrat : public ModelDiagramAdapter
{
Q_OBJECT
public:
    ChiQuadrat(QWidget* parent=0);

    ~ChiQuadrat();

    void loadData(QDataStream& s, int ver);
    void saveData(QDataStream& s, int ver);
    void setDiagram(Diagram *d);
    void setDepFilter(QString FilterWert,int Filter_Spalte);
    void setOutputFilter(const QVariant& fv);
    void setInputFilter(const QVariant& fv);
    
public slots:
	virtual void updateDiagram();

protected slots:
	void depAction();
	void undepAction();

protected:
	virtual double w(double x,double x0);
    
protected:
	QDoubleSpinBox *sX0,*sSigma,*sAlpha,*sN;
	QLabel *lChi;
	int N; // Zahl der Intervalle;
	QString filter_wert;
	QVariant input_filter,output_filter;
	int filter_spalte;
	double nu,si;
};

#endif
