//
// C++ Interface: test1
//
// Description:
//
//
// Author: Arne Schmitt <arne@as4m.de>, (C) 2006
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef _ModelDiagramAdapter_
#define _ModelDiagramAdapter_

#include "modelclient.h"
#include "diagramadapter.h"

class Diagram;
class QStandardItemModel;
class QGridLayout;

class ModelDiagramAdapter : public ModelClient,public DiagramAdapter
{
	Q_OBJECT
public:
	ModelDiagramAdapter(QWidget *parent=0);

	void setModel(QStandardItemModel *m);
	void setModelColumn(int c);
	virtual void setDiagram(Diagram *d);
	virtual void setTitle(const QString &t);
	Diagram *diagram();
	QStandardItemModel *model();
	int modelColumn();
	QVector<QAction*> actionList();
	
	virtual void saveData(QDataStream& s,int ver=1);
	virtual void loadData(QDataStream& s,int ver=1);

signals:
	void changeDiagram(DiagramAdapter*mda);
	
protected slots:
	virtual void updateDiagram()=0;
	void typAction();

protected:
	Diagram *td;
	int model_column;
	QGridLayout *glayout;
	QString _title;
	QVector<QAction*> actions;
	QAction *aTyp;
	
protected:
	void contextMenuEvent ( QContextMenuEvent * event );
};

#endif
